; BASIC startup command
*= $801
    ; !byte $01,$08 ; prg starting location
    !byte $0b,$08 ; basic next command address
    !byte $01,$00 ; basic line number
    !byte $9e,'2','0','6','1' ; SYS 2063 ($80F)
    !byte $00,$00,$00 ; empty BASIC command

*= $80D

; kernal functions
SETLFS  = $FFBA
SETNAME = $FFBD
LOAD    = $FFD5
READST  = $FFB7
CHROUT  = $FFD2

; hardware registers
VIA1_PB = $9F60
VIA1_PA = $9F61

; registers
ROM_BANK = VIA1_PB  ; note: will be replaced by ZP address $00-$01
RAM_BANK = VIA1_PA  ; note: will be replaced by ZP address $00-$01


    LDA #0              ; logical file number to 0
    LDX #8              ; device number to 8 (disk drive)
    LDY #0              ; activate secondary address mode
    JSR SETLFS

    ; load file 1
    LDA #1              ; \ switch to bank 1
    STA RAM_BANK        ; /
    LDA #6              ; size of filename
    LDX #<.file1        ; address of
    LDY #>.file1        ; file name
    JSR SETNAME         ; call SETNAME
    LDA #0              ; "load" mode
    LDX #$00            ; address where 
    LDY #$A0            ; to load
    JSR LOAD
    JSR READST          ; check if an error occured
    BEQ +               ; \
    JMP load_error      ;  | if error we jump to load_error or else we continue
+                       ; /
    ; load file 2
    LDA #2              ; \ switch to bank 2
    STA RAM_BANK        ; /
    LDA #6              ; size of filename
    LDX #<.file2        ; address of
    LDY #>.file2        ; file name
    JSR SETNAME         ; call SETNAME
    LDA #0              ; "load" mode (#1 = "verify" mode)
    LDX #$00            ; address where 
    LDY #$A0            ; to load
    JSR LOAD
    JSR READST          ; check if an error occured
    BEQ +               ; \
    JMP load_error      ;  | if error we jump to load_error or else we continue
+                       ; /

    ; and so on with file 3, 4, 5 ...
    ; at the end you can also load a file in place of
    ; this loader, just avoid overwriting memory where
    ; the code is currently being executed. You can 
    ; for example leave this kind of code in your first  
    ; bank and at last run it to load $0800 to $9EFF

    LDA #1              ; \ switch back to bank 1
    STA RAM_BANK        ; / 
    JSR $A000           ; run program in bank
    LDA #2              ; \ switch back to bank 2
    STA RAM_BANK        ; /
    JSR $A000           ; run program in bank
    RTS                 ; end of prg

load_error:
    LDX #0
-   LDA .error_str,x    ; print loop
    BEQ +               ; if the character is byte $00 we jump on the first '+' label after this line
    JSR CHROUT          ; print character on screen
    INX                 ; increment x
    JMP -               ; end of the loop, jump to the first '-' label before this line
+   RTS

.file1 !pet "b1.prg"
.file2 !pet "b2.prg"
.error_str !pet "load error!"